<?php
class Packs_Magento_Block_Adminhtml_System_Config_Form_Shipmentexportbutton extends Mage_Adminhtml_Block_System_Config_Form_Field
{
    /*
    * Set template
    */
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('packs_magento/system/config/button-shipmentexport.phtml');
    }

    /**
     * Return element html
     *
     * @param  Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        return $this->_toHtml();
    }

    /**
     * Return ajax url for button
     *
     * @return string
     */
    public function getAjaxRunUrl()
    {
        return Mage::helper('adminhtml')->getUrl('adminhtml/run/runShipmentExport');
    }

    /**
     * Generate button html
     *
     * @return string
     */
    public function getButtonHtml()
    {
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'shipmentexport',
                'label'     => $this->helper('adminhtml')->__('Check'),
                'onclick'   => "javascript:runShipmentExport(); return false;"
            ));

        return $button->toHtml();
    }
}