<?php
/**
 * Created by PhpStorm.
 * User: Diemer
 * Date: 13-11-2017
 * Time: 09:51
 */ 
class Packs_Magento_Helper_Data extends Mage_Core_Helper_Abstract {

    protected $apiUser;
    protected $apiUserPassword;
    protected $apiUrl;
    protected $apiAuthUrl;

    public function Authorize()
    {

        $this->apiUser = Mage::getStoreConfig('packs_magento_general/general/api_user');
        $this->apiUserPassword = Mage::getStoreConfig('packs_magento_general/general/api_user_password');
        $this->apiAuthUrl = Mage::getStoreConfig('packs_magento_general/general/api_auth_url');


        $postString = 'client_id=PacksOnlineApp&client_secret=secret&grant_type=password&scope=PacksOnlineAPI&username='.$this->apiUser.'&password='.$this->apiUserPassword;

        // PHP cURL  for https connection with auth
        $ch = curl_init();
        curl_setopt_array($ch, array(
            CURLOPT_URL => "".$this->apiAuthUrl."",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "".$postString."",
            CURLOPT_HTTPHEADER => array(
                "Cache-Control: no-cache",
                "Content-Type: application/x-www-form-urlencoded",
            ),
            CURLOPT_SSL_VERIFYPEER => false,
        ));

        $result = curl_exec($ch);

        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);
        unset($ch);

        $json = json_decode($result);
        $tokenData = array('type'=>$json->token_type, 'token'=>$json->access_token);

        return $tokenData;
    }

    public function getSenderData(){
        $senderData = array();
        $senderData['country'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_country');
        $senderData['city'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_city');
        $senderData['postcode'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_postcode');
        $senderData['street'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_street');
        $senderData['housenumber'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_housenumber');
        $senderData['numbext'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_numbext');
        $senderData['name'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_name');
        $senderData['contact'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_contact');
        $senderData['handler'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_handler');
        $senderData['network'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_network');
        $senderData['email'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_email');
        $senderData['reference'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_reference');
        return $senderData;
    }
}