<?php class Packs_Magento_Model_Export_GetProductinfo extends Mage_Core_Model_Abstract
{
    protected $apiUser;
    protected $apiUserPassword;
    protected $apiUrl;
    protected $apiAuthUrl;
    protected $oldTime;
    protected $orderIds;
    protected $postData;
    protected $shipments = array();
    protected $responses = array();
    protected $productoptions = array();
    protected $responseMessages = array();
    protected $aToken;
    protected $tToken;
    protected $continue;

    public function __construct()
    {
        $this->preProcessingExport();
        $this->ReturnResponse();
    }
    public function startMassExport()
    {
        $this->preProcessingExport();
    }
    public function preProcessingExport(){

        $this->apiUser = Mage::getStoreConfig('packs_magento_general/general/api_user');
        $this->apiUserPassword = Mage::getStoreConfig('packs_magento_general/general/api_user_password');
        $this->apiUrl =  Mage::getStoreConfig('packs_magento_general/general/api_getproductinfo_url');
        $this->apiAuthUrl = Mage::getStoreConfig('packs_magento_general/general/api_auth_url');
        $this->continue = true;
        set_time_limit(720000);                 // script timeout: 15 mins.
        ini_set('display_errors', 1);
        error_reporting(E_ALL);
        ini_set('max_execution_time', 720000);
        ini_set("default_charset", "utf-8");
        ini_set("memory_limit", "-1");
        ini_set("display_errors", "on");
        ob_start();

        $this->setOrderIds();
        $this->setPostData();

        $this->processingExport();
    }

    public function processingExport(){


        Mage::log('Get Productinfo STARTED',NULL,'getproductinfo.log');
        Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);

        $tokenData = Mage::helper('packs_magento')->Authorize();
        $this->tToken = $tokenData['type'];
        $this->aToken = $tokenData['token'];
        Mage::log('time 0: Authorize : ' . $this->getSeconds().' sec',NULL,'getproductinfo.log');

        if($this->continue == true) {
            $this->sendHandlerDataToWebservices();
            Mage::log('time 2: DATA TO WEBSERVICES : ' . $this->getSeconds() . ' sec', NULL, 'getproductinfo.log');
        }


    }


    public function getShipmentIdsFromMagento(){
        $orders = $this->orderIds;
        $shipmentCollection = Mage::getModel('packs_magento/shipment')
            ->getCollection()
            ->addFieldToFilter('magento_order_id', array('in' => $this->orderIds));

        foreach($shipmentCollection as $shipment){

                $shipmentData = $shipment->getData();

                $this->shipments[] = $shipmentData['packs_shipment_id'];

        }
    }

    public function sendHandlerDataToWebservices(){
        $senderData = $this->getSenderData();
        $handler = $senderData['handler'];
        $network = $senderData['network'];
            try {
                // xml post structure
                $xml_post_array = array(
                   'Handler' => (string)$handler,
                   'Network' => (string)$network
                );

                $xml_post_string = json_encode($xml_post_array);

                // PHP cURL  for https connection with auth
                $ch = curl_init();

                curl_setopt_array($ch, array(
                    CURLOPT_URL => "".$this->apiUrl."",
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => "",
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 30,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => "POST",
                    CURLOPT_POSTFIELDS => "".$xml_post_string."",
                    CURLOPT_HTTPHEADER => array(
                        "Accept: application/json",
                        "Authorization: ".$this->tToken." ".$this->aToken,
                        "Content-Type: application/json",
                        "cache-control: no-cache",
                    ),
                    CURLOPT_SSL_VERIFYPEER => false,

                ));

                $response = curl_exec($ch);

                if(empty($response)){
                    $response = curl_error($ch);
                    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                    curl_close($ch);
                    unset($ch);
                    $this->continue = false;
                    Mage::getSingleton('core/session')->addError('Api response is empty');

                }else{

                    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                    if($httpCode == 404) {
                        $message = "HTTP Error 404. The requested resource is not found. URL";
                        $this->responseMessages['errors'] = $message;
                        return;
                    }
                    if($httpCode == 400) {
                        $message = $response;
                        $this->responseMessages['errors'] = $message;
                        $this->continue = false;
                        return;
                    }
                    if($httpCode == 503) {
                        $message = "HTTP Error 503. The api server is not available";
                        $this->responseMessages['errors'] = $message;
                        $this->continue = false;
                        return;
                    }
                    if (curl_errno($ch)) {
                        $err = curl_error($ch);
                        curl_close($ch);

                        $message = $err;
                        $this->responseMessages['errors'] = $message;

                    }

                    $jsonDecoded = json_decode($response,true);
                    curl_close($ch);
                    unset($ch);

                    $this->responses = $jsonDecoded;
                    $this->productoptions = $this->responses->products;
                }

            }catch (Exception $e) {
                Mage::log('time 4.1: ' . time(). ' : '.$e->getMessage(),NULL,'getproductinfo.log');
                Mage::logException($e);

                // send email
                if($this->sendErrorMail == true){
                    $this->helper->sendErrorMail($e->getMessage(),$this->sendErrorMailTo);
                }
            }
    }

    public function responseHandler(){
        foreach($this->responses as $productoption){
            if((string)$xml->Body->Fault->faultcode){
                $pieces = explode('--->',(string)$xml->Body->Fault->faultstring);
                $pieces = explode('bij Shipment.InsertShipment',$pieces[1]);
                $message = $pieces[0];
                $this->responseMessages['errors'][$incrementId] = $message;
            }
            if((string)$xml->Body->InsertShipmentBasicResponse->InsertShipmentBasicResult->diffgram->NewDataSet->CheckBalance->error){
                $message = (string)$xml->Body->InsertShipmentBasicResponse->InsertShipmentBasicResult->diffgram->NewDataSet->CheckBalance->error;
                $this->responseMessages['errors'][$incrementId] = $message;
            }

            if(isset($this->responseMessages['errors'])){
                if(array_key_exists($incrementId, $this->responseMessages['errors'])){
                    unset($this->responses[$incrementId]);
                }
            }
        }
    }


    public function getSeconds(){
        if(!isset($this->oldTime)){
            $this->oldTime = time();
        }
        $newTime = time();
        $seconds = $newTime - $this->oldTime;
        $this->oldTime = $newTime;
        return $seconds;
    }


    public function setPostData()
    {
        $postData = Mage::getSingleton('packs_magento/export_data')->getData('postData');
        $this->postData = $postData;
    }

    public function getSenderData(){
        $senderData = array();
        $senderData['country'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_country');
        $senderData['city'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_city');
        $senderData['postcode'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_postcode');
        $senderData['street'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_street');
        $senderData['housenumber'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_housenumber');
        $senderData['numbext'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_numberext');
        $senderData['name'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_name');
        $senderData['contact'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_contact');
        $senderData['handler'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_handler');
        $senderData['network'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_network');
        $senderData['email'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_email');
        $senderData['reference'] = Mage::getStoreConfig('packs_magento_shipments/sender_info/sender_reference');
        return $senderData;
    }

    public function returnResponse(){
        $this->setData('responses',$this->responses);
    }

}