<?php

use PACKS\SHIPMENTS\Admin\AdminNotice;

class Packs_Magento_Model_Export_GetTracktrace extends Mage_Core_Model_Abstract
{
    protected $apiUser;
    protected $apiUserPassword;
    protected $apiUrl;
    protected $apiAuthUrl;
    protected $orderIds;
    protected $shipments;
    protected $shipmentId;
    protected $_shipmentsData;
    protected $aToken;
    protected $tToken;
    protected $continue;
    protected $shipmentItems;
    //protected $orders = array();
    protected $response;
    protected $responses = array();
    protected $responseMessages = array();
    protected $helper;

    public function __construct($shipmentids)
    {
        $this->shipments = $shipmentids;
        $this->preprocessData();
        $this->_responses = $this->responses;

    }

    public function preprocessData()
    {
        $this->apiUser = Mage::getStoreConfig('packs_magento_general/general/api_user');
        $this->apiUserPassword = Mage::getStoreConfig('packs_magento_general/general/api_user_password');
        $this->apiUrl =  Mage::getStoreConfig('packs_magento_general/general/api_tracktrace_url');
        $this->apiAuthUrl = Mage::getStoreConfig('packs_magento_general/general/api_auth_url');
        $this->helper = Mage::helper('packs_magento');


        $tokenData = Mage::helper('packs_magento')->Authorize();
        $this->tToken = $tokenData['type'];
        $this->aToken = $tokenData['token'];

        foreach($this->shipments as $shipmentitem){
            $this->processData($shipmentitem);
        }

    }

    public function processData($data)
    {


        $i=1;

        $senderData = $this->helper->getSenderData();
        $handler = $senderData['handler'];
        $network = $senderData['network'];
        try {
            // xml post structure
            $xml_post_array = array(
                'shipmentId' => $data


            );

            $xml_post_string = json_encode($xml_post_array);


            // PHP cURL  for https connection with auth
            $ch = curl_init();
            $url = $this->apiUrl.'/'.$data;
            curl_setopt_array($ch, array(
                CURLOPT_URL => "".$url."",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                    "Accept: application/json",
                    "Authorization: ".$this->tToken." ".$this->aToken,
                    "Content-Type: application/json",
                    "cache-control: no-cache",
                ),
                CURLOPT_SSL_VERIFYPEER => false,

            ));

            $response = curl_exec($ch);


            if(empty($response)){
                $response = curl_error($ch);
                $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                curl_close($ch);
                unset($ch);
                $this->continue = false;
                Mage::getSingleton('core/session')->addError('Api response is empty');
                return;
            }else{

                $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($httpCode == 404) {
                    $message = "HTTP Error 404. The requested resource is not found. URL";
                    $this->responseMessages['errors'][$i['id']] = $message;
                    return;
                }
                if($httpCode == 400) {
                    $message = $response;
                    $this->responseMessages['errors'][$i['id']] = $message;
                    $this->continue = false;
                    return;
                }
                if($httpCode == 503) {
                    $message = "HTTP Error 503. The api server is not available";
                    $this->responseMessages['errors'][$i['id']] = $message;
                    $this->continue = false;
                    return;
                }
                if (curl_errno($ch)) {
                    $err = curl_error($ch);
                    curl_close($ch);

                    $message = $err;
                    $this->responseMessages['errors'][$i['id']] = $message;

                }

                $jsonDecoded = json_decode($response,true);
                curl_close($ch);
                unset($ch);

                array_push($this->responses,$jsonDecoded);
                $test = "test";
                //$responseArray[$order['id']] = $this->array_push_assoc($responseArray[$order['id']], 'orderId', $order['id']);
                //$this->responses[$order['id']] = $responseArray[$order['id']];
            }



        }catch (Exception $e) {
            Mage::log('time 4.1: ' . time(). ' : '.$e->getMessage(),NULL,'gettracktrace.log');
            Mage::logException($e);
        }



    }

}