<?php class Packs_Magento_Model_Export_Labels extends Mage_Core_Model_Abstract
{
    protected $oldTime;
    protected $orderIds;
    protected $labels;
    protected $tracktrace;
    protected $orders = array();
    protected $shipmentitems = array();

    public function startPdfExport($orderIds)
    {
        return $this->preProcessingPdfCreation($orderIds);
    }

    public function preProcessingPdfCreation($orderIds){

        set_time_limit(720000);                 // script timeout: 15 mins.
        ini_set('display_errors', 1);
        error_reporting(E_ALL);
        ini_set('max_execution_time', 720000);
        ini_set("default_charset", "utf-8");
        ini_set("memory_limit", "-1");
        ini_set("display_errors", "on");
        ob_start();

        $this->setOrderIds($orderIds);

        return $this->processingPdfCreation();
    }

    public function processingPdfCreation(){


        Mage::log('EXPORT STARTED',NULL,'shipmentexport.log');
        Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);

        $this->getShipmentIdsFromMagento();

        $this->getShipmentLabels();
        Mage::log('time 1: SHIPMENT LABELS DATA : ' . $this->getSeconds().' sec',NULL,'shipmentexportlabels.log');
        $this->getShipmentTracktrace();
        $this->saveTracktrace();

        $pdf = $this->createLabelsPdf();
        Mage::log('time 2: PDF CREATED : ' . $this->getSeconds().' sec',NULL,'shipmentexportlabels.log');

        return $pdf;
    }

    public function getShipmentIdsFromMagento(){
        $orders = $this->orderIds;
        $shipmentItemCollection = Mage::getModel('packs_magento/shipmentitems')
            ->getCollection()
            ->addFieldToFilter('magento_order_id', array('in' => $this->orderIds));

        foreach($shipmentItemCollection as $shipmentitem){

            $shipmentData = $shipmentitem->getData();

            $this->shipmentitems[] = $shipmentData['packs_shipment_id'];

        }
    }

    public function getShipmentLabels(){
        $getlabels = new Packs_Magento_Model_Export_Getlabels($this->shipmentitems);
        $this->labels = $getlabels->getData();

    }

    public function getShipmentTracktrace(){
        $gettracktrace = new Packs_Magento_Model_Export_GetTracktrace($this->shipmentitems);
        $this->tracktrace = $gettracktrace->getData();

    }

    public function createLabelsPdf()
    {
        $pdfDirPath = Mage::getBaseDir('var') . DS . 'pdf' . DS;
        $pdfDirPathTemp = Mage::getBaseDir('var') . DS . 'pdf' . DS . 'tmp' . DS;

        if (!file_exists($pdfDirPath)) {
            mkdir($pdfDirPath, 0777, true);
        }
        if (!file_exists($pdfDirPathTemp)) {
            mkdir($pdfDirPathTemp, 0777, true);
        }

        $pdfDocs = array();
        $i=0;
        foreach ($this->labels as $labelData) {
            $i++;
            //Decode pdf content
            $pdf_decoded = base64_decode($labelData['labels'][0]['labelObject']);
            //Write data back to pdf file
            $filename = $pdfDirPathTemp . $labelData['magento_shipment_id'].'-'.$i.'-test.pdf';
            $pdf = fopen($filename, 'w');
            if(!$pdf_decoded == ''){
                fwrite($pdf, $pdf_decoded);
                //close output file
                fclose($pdf);
                array_push($pdfDocs, $filename);
            }else{
                return false;

            }

        }

        /* CREATE ONE FILE OUT OF IT */
        if(!$pdf_decoded == '') {
            $pdf = new Packs_Magento_PDFMerger(); // or use $pdf = new \PDFMerger; for Laravel
            foreach ($pdfDocs as $doc) {
                $pdf->addPDF($doc, 'all');
            }
            $now = date("YmdHis");
            $mergedFileName = $pdfDirPath . $now . '.pdf';
            $pdf->merge('file', $mergedFileName); // generate the file


            $fileToDelete = glob($pdfDirPathTemp . '*');
            foreach ($fileToDelete as $file) {
                if (is_file($file))
                    unlink($file);
            }
            return $mergedFileName;
        }else{
            return false;
        }
    }

    public function saveTracktrace()
    {
        if($this->tracktrace){
            foreach ($this->tracktrace["_responses"] as $tracktraceData) {
                $shipmentItemCollection = Mage::getModel('packs_magento/shipmentitems')
                    ->getCollection()
                    ->addFieldToFilter('packs_shipment_id', array('in' => $tracktraceData['batch']));

                foreach ($shipmentItemCollection as $shipmentitem) {
                    $shipmentData = $shipmentitem->getData();
                    $shipmentId = $shipmentData['magento_shipment_id'];
                }
                $shipment = Mage::getModel('sales/order_shipment');
                $shipment->loadByIncrementId($shipmentId);
                $tracksCollection = $shipment->getTracksCollection();
                $trackNumbers = NULL;
                foreach ($tracksCollection->getItems() as $track) {
                    $trackNumbers[] = $track->getTrackNumber();
                }
                if ($shipment->getId() != '' && empty($trackNumbers)) {
                    $track = Mage::getModel('sales/order_shipment_track')
                        ->setNumber($tracktraceData['trackAndTraceUrl']) //tracking number / awb number
                        ->setCarrierCode('custom') //carrier code
                        ->setTitle($tracktraceData['batch']); //carrier title
                    $shipment->addTrack($track);

                    $transactionSave = Mage::getModel('core/resource_transaction')
                        ->addObject($shipment)
                        ->addObject($shipment->getOrder())
                        ->save();
                }else{
                    return;
                }

            }
        }

    }

    public function setOrderIds($orderIds){
        $this->orderIds = $orderIds;
    }

}