<?php
class Packs_Magento_Model_Observer extends Mage_Core_Model_Abstract
{
    protected $enabled;

    public function ShipmentExport()
    {
        $this->enabled = Mage::getStoreConfig('packs_magento_shipments/export/enabled');
        if($this->enabled){
            Mage::getModel('packs_magento/export_shipment')->startExport();
        }
    }

    public function addMassAction($observer)
    {
        if (Mage::getSingleton('admin/session')->isAllowed('sales/order/actions/packs')) {
            $block = $observer->getEvent()->getBlock();
            if (get_class($block) == 'Mage_Adminhtml_Block_Widget_Grid_Massaction'
                && $block->getRequest()->getControllerName() == 'sales_order') {
                $block->addItem('packs_magento_export', array(
                    'label' => 'Packs :: Voormelden & Magento verzending aanmaken',
                    'url' => Mage::app()->getStore()->getUrl('adminhtml/run/massshipmentprepare'),
                ));


                $block->addItem('packs_magento_labelprint', array(
                    'label' => 'Packs :: Labels printen',
                    'url' => Mage::app()->getStore()->getUrl('adminhtml/run/masslabelprint'),
                ));
            }
        }
    }

    public function appendOrderColumns(Varien_Event_Observer $observer){
        $block = $observer->getBlock();
        if (!isset($block)) {
            return $this;
        }

        if ($block->getType() == 'adminhtml/sales_order_grid') {
            /* @var $block Mage_Adminhtml_Block_Customer_Grid */
            $block->addColumnAfter('packs_confirm_status', array(
                'header'    => 'Packs voormeldstatus',
                'type'      => 'text',
                'index'     => 'packs_confirm_status',
                'width'     => '70px',
                'renderer'  => 'Packs_Magento_Block_Adminhtml_Widget_Grid_Column_Renderer_Status',
            ), 'shipping_name');
            $block->addColumnAfter('packs_confirm_date', array(
                'header'    => 'Packs voormeld datum',
                'type'      => 'text',
                'index'     => 'packs_confirm_date',
                'width'     => '70px',
//                'renderer'  => 'packs_magento_adminhtml/widget_grid_column_renderer_confirmDate',
            ), 'packs_confirm_status');
        }
    }

    public function salesOrderGridCollectionLoadBefore($observer)
    {
        $collection = $observer->getEvent()->getOrderGridCollection(); // grid collection
        $collection->getSelect()->joinLeft(
            'packs_magento_shipment',
            'main_table.entity_id = packs_magento_shipment.magento_order_id',
            array('packs_confirm_date','packs_confirm_status')
        );
    }

}