<?php class Packs_Magento_Adminhtml_RunController extends Mage_Adminhtml_Controller_Action
{
    protected $enabled;

    public function runShipmentExportAction()
    {
        $this->enabled = Mage::getStoreConfig('packs_magento_shipments/export/enabled');
        if($this->enabled){
            Mage::getModel('packs_magento/export_shipment')->startExport();
        }
    }

    public function massShipmentPrepareAction() {
        $this->enabled = Mage::getStoreConfig('packs_magento_shipments/export/enabled');
        if($this->enabled){
            $orderIds = $this->getRequest()->getPost('order_ids', array());
            Mage::getSingleton('packs_magento/export_data')->setData('orderIds',$orderIds);
            $this->loadLayout();
            $this->renderLayout();
        }
    }

    public function massShipmentExportAction() {
        $this->enabled = Mage::getStoreConfig('packs_magento_shipments/export/enabled');
        if($this->enabled){
            $postData = $this->getRequest()->getPost();
            $orderIds = explode(",", $this->getRequest()->getPost('order_ids', array()));
            Mage::getSingleton('packs_magento/export_data')->setData('orderIds',$orderIds);
            Mage::getSingleton('packs_magento/export_data')->setData('postData',$postData);

            Mage::getModel('packs_magento/export_shipment')->startMassExport();
        }
        $this->_redirect('adminhtml/sales_order/');
    }

    public function massLabelPrintAction() {

        $this->enabled = Mage::getStoreConfig('packs_magento_shipments/export/enabled');
        if($this->enabled){
            $orderIds = $this->getRequest()->getPost('order_ids', array());
            $pdf = Mage::getModel('packs_magento/export_labels')->startPdfExport($orderIds);
        }
        if($pdf == false){
            Mage::getSingleton('core/session')->addError('Labels not available');
            $this->_redirect('adminhtml/sales_order/');

        }else{
            if (file_exists($pdf)) {
                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header('Content-Disposition: attachment; filename="'.basename($pdf).'"');
                header('Expires: 0');
                header('Cache-Control: must-revalidate');
                header('Pragma: public');
                header('Content-Length: ' . filesize($pdf));
                readfile($pdf);
                exit;
            }
//
            Mage::getSingleton('core/session')->addSuccess('Labels printed');
            $this->_redirect('adminhtml/sales_order/');
        }

    }


    //Functie voor dynamisch ophalen productinfo (Ajax call)
//    public function getProductsinfo(){
//        $handler = $this->getRequest()->getPost('handler', array());
//        $network = $this->getRequest()->getPost('network', array());
//    }

    protected function _isAllowed()
    {
        return Mage::getSingleton('admin/session')->isAllowed('sales/order/actions/packs');
    }

}