<?php
/**
 * Created by PhpStorm.
 * User: Diemer
 * Date: 23-11-2017
 * Time: 16:24
 */
/* @var $installer Mage_Core_Model_Resource_Setup */
$installer = $this;

$this->startSetup();

$tableName = $installer->getTable('packs_magento/packs_magento_shipment');
if (!$conn->isTableExists($tableName)) {
    $packsShipmentTable = $installer->getConnection()
        ->newTable($tableName)
        ->addColumn('entity_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'identity'  => true,
            'unsigned'  => true,
            'nullable'  => false,
            'primary'   => true,
        ), 'Entity Id')
        ->addColumn('magento_order_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Magento Shipment Id')
        ->addColumn('magento_shipment_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Magento Shipment Id')
        ->addColumn('packs_shipment_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Packs Shipment Id')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
            'nullable'  => false,
        ), 'Created At')
        ->addColumn('load_date', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
            'nullable'  => true,
        ), 'Updated At')
        ->addColumn('delivery_date', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
            'nullable'  => true,
        ), 'Confirmed At')
        ->addColumn('confirm_date', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array(
            'nullable'  => false,
        ), 'Confirm Date')
        ->addColumn('confirm_status', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
        ), 'Confirm Status')
        ->addColumn('shipment_type', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable' => true,
        ), 'Shipment Type')
        ->addColumn('seal_type', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable' => true,
        ), 'Seal Type')
        ->addColumn('collie', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable' => true,
        ), 'Collie')
        ->addColumn('weight', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable' => true,
        ), 'Weight')
        ->addColumn('reference', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable' => true,
        ), 'Reference')
        ->addIndex($installer->getIdxName('packs_magento/packs_magento_shipment', array('magento_shipment_id'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE),
            array('magento_shipment_id'),
            array('type' => Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE))
        ->setComment('Packs Shipment');

    $installer->getConnection()->createTable($packsShipmentTable);
}

$tableName = $installer->getTable('packs_magento/packs_magento_labels');
if (!$conn->isTableExists($tableName)) {
    $packsShipmentLabelTable = $installer->getConnection()
        ->newTable($tableName)

        ->addColumn('label_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'identity'  => true,
            'unsigned'  => true,
            'nullable'  => false,
            'primary'   => true,
        ), 'Label Id')

        ->addColumn('magento_order_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Magento Order Id')

        ->addColumn('magento_shipment_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Magento Shipment Id')

        ->addColumn('packs_shipment_id', Varien_Db_Ddl_Table::TYPE_INTEGER, 10, array(
            'unsigned'  => true,
            'nullable'  => true,
        ), 'Packs Shipment Id')

        ->addColumn('label', Varien_Db_Ddl_Table::TYPE_BLOB, 16777216 /* 2^24 (medium blob) */, array(
            'nullable'  => false,
        ), 'Label')

        ->addColumn('label_type', Varien_Db_Ddl_Table::TYPE_TEXT, 32, array(
            'nullable'  => false,
        ), 'Label Type')
        ->addIndex($installer->getIdxName('packs_magento/packs_magento_labels', array('magento_order_id')),
            array('magento_order_id'))
        ->setComment('Packs Shipment Label');

    $installer->getConnection()->createTable($packsShipmentLabelTable);
}

$this->endSetup();